/* ***** BEGIN LICENSE BLOCK *****
 * Licensed	under Version: MPL 1.1/GPL 2.0/LGPL	2.1
 * Full	Terms at http://mozile.mozdev.org/license.html
 *
 * Software	distributed	under the License is distributed on	an "AS IS" basis,
 * WITHOUT WARRANTY	OF ANY KIND, either	express	or implied.	See	the	License
 * for the specific	language governing rights and limitations under	the
 * License.
 *
 * The Original	Code is	Playsophy code.
 *
 * The Initial Developer of	the	Original Code is Playsophy
 * Portions	created	by the Initial Developer are Copyright (C) 2002-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *		James A. Overton <james@overton.ca>
 *		Andreas	Schamberger	<mozile@andreass.net>
 *		Paul Everitt
 *
 * ***** END LICENSE BLOCK ***** */

	// Fake	Presets
var	PagePresets	= new Array();
PagePresets['saveContent'] = "page";
PagePresets['saveMethod'] =	"display";
PagePresets['httpSavePath']	= "";

var	UserPresets	= new Array();
UserPresets['saveContent'] = "page";
UserPresets['saveMethod'] =	"display";
UserPresets['httpSavePath']	= "http://yahoo.ca";

var	CurrentSettings	= new Array();
CurrentSettings['saveContent'] = "page";
CurrentSettings['saveMethod'] =	"display";
CurrentSettings['httpSavePath']	= "";

var	mozileTarget = opener.mozileGetCurrentTarget();
var mozilePrefs = "";

	// Initialize the dialog
function init()	
{
	var	f =	["save.js","init"];
	opener.mozileDebug(f,3,"Initializing");
try{	

	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
    mozilePrefs = Components.classes["@mozilla.org/preferences-service;1"].
        getService(Components.interfaces.nsIPrefBranch);

	mozileGetUserPresets();

	mozileSetVersionById('version');
	opener.mozileDebug(f,3,"Target:	"+mozileTarget);
	if(mozileTarget && mozileTarget!="") {
		PagePresets = mozileTarget.document.MOZILE_RSD_CONFIG;
		CurrentSettings = mozileTarget.document.MOZILE_CURRENT_CONFIG;
		switch(CurrentSettings['preset']) {
			case 'page': 
				mozileSetPreset('page');
				mozileApplyPresets('page');	
				break;
			case'user':
				mozileSetPreset('user');
				mozileApplyPresets('user');
				break;
			default:
				mozileSetPreset('custom');
				mozileApplyPresets('custom');
				break;
		}
	}
	else {
		mozileSetPreset('user');
		mozileApplyPresets('user');
	}
	mozileSaveToBox();
	opener.mozileDebug(f,3,"Done Initializing");
	
} catch(e) {
	opener.mozileDebug(f,3,"Error Initializing: "+e);
}
}
	
	// Called when the user clicks "OK"
function mozileAccept() {
	var	f =	["save.js","mozileAccept"];
	opener.mozileDebug(f,2,"Accepting...");
		// store all the settings
	try {
	CurrentSettings['preset']=document.getElementById('mozileSavePresets').value;
	CurrentSettings['saveContent']=document.getElementById('mozileSaveContent').value;
	CurrentSettings['saveMethod']=document.getElementById('mozileSaveMethod').value;
	CurrentSettings['httpSavePath']=document.getElementById('mozileSaveTo').value;
		// call mozileSave
	//alert("Saving: "+CurrentSettings['saveContent']+CurrentSettings['saveMethod']);
		opener.mozileSave();
		opener.mozileDebug(f,2,"Saved!");
	} catch(e) {
		opener.mozileDebug(f,2,"Save Error: "+e);
	}
}

	// Stupid
var	mozileIndices =	new	Array();
mozileIndices['file'] =	0;
mozileIndices['local'] = 0;
mozileIndices['alert'] = 1;
mozileIndices['display'] = 1;
mozileIndices['post'] =	2;
mozileIndices['webdav']	= 3;
mozileIndices['page'] =	0;
//mozileIndices['editable'] =	1;
mozileIndices['current'] = 1;
	// old
mozileIndices['false'] = 0;
mozileIndices['true'] =	1;


function mozileGetUserPresets() {
	UserPresets['saveContent'] = mozilePrefs.getCharPref("mozile.saveContentString");
	UserPresets['saveMethod'] =	mozilePrefs.getCharPref("mozile.saveMethodString");
	UserPresets['httpSavePath']	= mozilePrefs.getCharPref("mozile.saveHttpPathString");
}

	// Store the User Preset
function mozileStorePreset(node) {
	var	f =	["save.js","mozileStorePresets"];
	opener.mozileDebug(f,3,"Storing...");
try{
		// Set local array
	UserPresets['saveContent'] = document.getElementById('mozileSaveContent').value;
	UserPresets['saveMethod'] =	document.getElementById('mozileSaveMethod').value;
	UserPresets['httpSavePath']	= document.getElementById('mozileSaveTo').value;
	mozileSetPreset('user');

		// Store to the Mozilla preferences
	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
	mozilePrefs.setCharPref("mozile.saveContentString", document.getElementById('mozileSaveContent').value);
	mozilePrefs.setCharPref("mozile.saveMethodString", document.getElementById('mozileSaveMethod').value);
	mozilePrefs.setCharPref("mozile.saveHttpPathString", document.getElementById('mozileSaveTo').value);
	
	opener.mozileDebug(f,3,"Stored!");
	
} catch(e) {
	opener.mozileDebug(f,2,"Store Error: "+e);
	
}
}


	//When a Preset calue is chosen, do some work
function mozilePreset(node)	{
	mozileApplyPresets(node.value);
	CurrentSettings['preset']=node.value;
	mozileSaveToBox();
}

	// Change all of the form values to match the chosen Preset
function mozileApplyPresets(preset)	{
	var	presetArray	= new Array();
	switch(preset) {
		case 'page': var presetArray = PagePresets;	break;
		case 'user': var presetArray = UserPresets;	break;
		default: var presetArray = CurrentSettings; break;
	}

	var	saveContent	= mozileIndices[presetArray['saveContent']];
	var	saveMethod = mozileIndices[presetArray['saveMethod']];
	var	path = presetArray['httpSavePath'];
	document.getElementById('mozileSaveContent').selectedIndex = saveContent;
	document.getElementById('mozileSaveMethod').selectedIndex =	saveMethod;
	document.getElementById('mozileSaveTo').value =	path;
}



	// Decide whether or not to show the "Save To" field
function mozileSaveToBox() {
	var	box	= document.getElementById('mozileSaveToBox');
	var	saveMethod = document.getElementById('mozileSaveMethod').value;
	switch(saveMethod) {
		case 'local': box.collapsed=true; break;
		case 'dialog': box.collapsed=true; break;
		case 'post': box.collapsed=false; break;
		case 'webdav': box.collapsed=true; break;
		default: box.collapsed=true; break;
	}
}

	// When the content menu changes, just change the Preset menu to "Custom"
function mozileSaveContent(node) {
	mozileSetPreset('custom');
}

	// When the method menu changes, change the Preset menu to "Custom", and show or hide the Save To field
function mozileSaveMethod(node)	{
	mozileSetPreset('custom');
	mozileSaveToBox();
}

	// When the Save To filed changes, do nothing...
function mozileSaveTo(node)	{
	//if(node.value	!= UserPreset['httpSavePath'] && node.value	!= PagePreset['httpSavePath'])	mozileSetPreset('custom');
}

	// Set the Preset menu to the given value
function mozileSetPreset(value)	{
	var	presetMenu = document.getElementById('mozileSavePresets');
	switch(value) {
		case 'page': presetMenu.selectedIndex=0; break;
		case 0:	presetMenu.selectedIndex=0;	break;
		case 'user': presetMenu.selectedIndex=1; break;
		case 1:	presetMenu.selectedIndex=1;	break;
		default: presetMenu.selectedIndex=2; break;
	}
}
